package ListBits ( listBits ) where

import List
import Monad

listBits :: Bit n -> List (Bit 1)
listBits vec = let f x = let x' = fromInteger x
			 in  vec[x':x']
		   max = (valueOf n) - 1
	       in  map f (upto 0 max)


-- Example usage: a function to compute if any bit in a vector is set
isAnySet :: Bit n -> Bool
isAnySet vec = foldr (\b r -> (b == 1) || r) False (listBits vec)

